• LeetCode 162 Find Peak Element


    Problem:

    A peak element is an element that is greater than its neighbors.

    Given an input array where num[i] ≠ num[i+1], find a peak element and return its index.

    The array may contain multiple peaks, in that case return the index to any one of the peaks is fine.

    You may imagine that num[-1] = num[n] = -∞.

    For example, in array [1, 2, 3, 1], 3 is a peak element and your function should return the index number 2.

    Your solution should be in logarithmic complexity.

    Summary:

    找到数组中的局部最大数。

    Solution:

    1. 顺序查找:最直接的方法,复杂度为O(n)

     1 class Solution {
     2 public:
     3     int findPeakElement(vector<int>& nums) {
     4         int len = nums.size();
     5         if (len == 1) {
     6             return 0;
     7         }
     8         
     9         for (int i = 0; i < len; i++) {
    10             if (!i && nums[i] > nums[i + 1] || 
    11                 i == len - 1 && nums[i] > nums[i - 1] ||
    12                 nums[i] > nums[i - 1] && nums[i] > nums[i + 1]) {
    13                     return i;
    14                 }
    15         }
    16         
    17         return -1;
    18     }
    19 };

    2. 二分查找:首先找到整体的中间值m,若m符合局部最大条件则返回m,否则若nums[m - 1] > nums[m]则在[0, m - 1]中查找。因为数组左边和右边为负无穷,所以在这种情况下[0, m - 1]中一定存在一个局部最大值。这种方法复杂度为O(logn)。

     1 class Solution {
     2 public:
     3     int findPeakElement(vector<int>& nums) {
     4         int len = nums.size();
     5         if (len == 1) {
     6             return 0;
     7         }
     8         
     9         int l = 0, r = len - 1;
    10         while (l <= r) {
    11             int m = (l + r) / 2;
    12             if ((!m || nums[m] >= nums[m - 1]) &&
    13                 (m == len - 1 || nums[m] >= nums[m + 1])) {
    14                     return m;
    15                 }
    16             if (m && nums[m] < nums[m - 1]) {
    17                 r = m - 1;
    18             }   
    19             else {
    20                 l = m + 1;
    21             }
    22         }
    23         
    24         return -1;
    25     }
    26 };

    二分查找的简略写法:

     1 class Solution {
     2 public:
     3     int findPeakElement(vector<int>& nums) {
     4         int len = nums.size();
     5         if (len == 1) {
     6             return 0;
     7         }
     8         
     9         int l = 0, r = len - 1;
    10         while (l < r) {
    11             int m = (l + r) / 2;
    12             if (nums[m] > nums[m + 1]) {
    13                 r = m;
    14             }
    15             else {
    16                 l = m + 1;
    17             }
    18         }
    19         
    20         return r;
    21     }
    22 };
  • 相关阅读:
    不同编程语言中获取现在的Unix时间戳
    Zend Studio8.0.0中文汉化教程及入门教程
    Apache+php+mysql在windows下的安装与配置图解
    SQl 跨服务器查询语句和跨数据创建表
    .NET平台依赖注入机制及IoC的设计与实现
    整理基础的CentOS常用命令
    jQuery boxy弹出层插件中文演示及讲解
    VB 冒泡排序
    Windows7下使用IIS7与FastCGI模块配置PHP5.3.1运行环境
    Eclipse快捷键大全(转载)
  • 原文地址:https://www.cnblogs.com/VickyWang/p/6242160.html
Copyright © 2020-2023  润新知